---
title: Create a personal access token
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Key Management
---

# Create a personal access token{% #create-a-personal-access-token %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                     |
| ----------------- | ---------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/personal_access_tokens |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/personal_access_tokens |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/personal_access_tokens      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/personal_access_tokens      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/personal_access_tokens  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/personal_access_tokens     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/personal_access_tokens |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/personal_access_tokens |

### Overview

Create a personal access token for the current user. This endpoint requires the `user_app_keys` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type      | Description                                                                         |
| ------------ | ---------------------------- | --------- | ----------------------------------------------------------------------------------- |
|              | data [*required*]       | object    | Object used to create an access token.                                              |
| data         | attributes [*required*] | object    | Attributes used to create an access token.                                          |
| attributes   | expires_at [*required*] | date-time | Expiration date of the access token. Must be at least 24 hours in the future.       |
| attributes   | name [*required*]       | string    | Name of the access token.                                                           |
| attributes   | scopes [*required*]     | [string]  | Array of scopes to grant the access token.                                          |
| data         | type [*required*]       | enum      | Personal access tokens resource type. Allowed enum values: `personal_access_tokens` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "personal_access_tokens",
    "attributes": {
      "name": "Example-Key-Management",
      "scopes": [
        "dashboards_read"
      ],
      "expires_at": "2022-11-11T11:11:11+00:00"
    }
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response for creating an access token. Includes the token key.

| Parent field  | Field                  | Type      | Description                                                                         |
| ------------- | ---------------------- | --------- | ----------------------------------------------------------------------------------- |
|               | data                   | object    | Datadog access token, including the token key.                                      |
| data          | attributes             | object    | Attributes of a full access token, including the token key.                         |
| attributes    | created_at             | date-time | Creation date of the access token.                                                  |
| attributes    | expires_at             | date-time | Expiration date of the access token.                                                |
| attributes    | key                    | string    | The access token key. Only returned upon creation.                                  |
| attributes    | name                   | string    | Name of the access token.                                                           |
| attributes    | public_portion         | string    | The public portion of the access token.                                             |
| attributes    | scopes                 | [string]  | Array of scopes granted to the access token.                                        |
| data          | id                     | string    | ID of the access token.                                                             |
| data          | relationships          | object    | Resources related to the access token.                                              |
| relationships | owned_by               | object    | Relationship to user.                                                               |
| owned_by      | data [*required*] | object    | Relationship to user object.                                                        |
| data          | id [*required*]   | string    | A unique identifier that represents the user.                                       |
| data          | type [*required*] | enum      | Users resource type. Allowed enum values: `users`                                   |
| data          | type                   | enum      | Personal access tokens resource type. Allowed enum values: `personal_access_tokens` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2024-01-01T00:00:00+00:00",
      "expires_at": "2025-12-31T23:59:59+00:00",
      "key": "string",
      "name": "My Access Token",
      "public_portion": "ddpat_abc123",
      "scopes": [
        "dashboards_read",
        "dashboards_write"
      ]
    },
    "id": "string",
    "relationships": {
      "owned_by": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      }
    },
    "type": "personal_access_tokens"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/personal_access_tokens" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "expires_at": "2025-12-31T23:59:59+00:00",
      "name": "My Personal Access Token",
      "scopes": [
        "dashboards_read",
        "dashboards_write"
      ]
    },
    "type": "personal_access_tokens"
  }
}
EOF 
                        
##### 

```go
// Create a personal access token returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"
	"time"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.PersonalAccessTokenCreateRequest{
		Data: datadogV2.PersonalAccessTokenCreateData{
			Type: datadogV2.PERSONALACCESSTOKENSTYPE_PERSONAL_ACCESS_TOKENS,
			Attributes: datadogV2.PersonalAccessTokenCreateAttributes{
				Name: "Example-Key-Management",
				Scopes: []string{
					"dashboards_read",
				},
				ExpiresAt: time.Now().AddDate(0, 0, 365),
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewKeyManagementApi(apiClient)
	resp, r, err := api.CreatePersonalAccessToken(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `KeyManagementApi.CreatePersonalAccessToken`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `KeyManagementApi.CreatePersonalAccessToken`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Create a personal access token returns "Created" response
import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.KeyManagementApi;
import com.datadog.api.client.v2.model.PersonalAccessTokenCreateAttributes;
import com.datadog.api.client.v2.model.PersonalAccessTokenCreateData;
import com.datadog.api.client.v2.model.PersonalAccessTokenCreateRequest;
import com.datadog.api.client.v2.model.PersonalAccessTokenCreateResponse;
import com.datadog.api.client.v2.model.PersonalAccessTokensType;
import java.time.OffsetDateTime;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    KeyManagementApi apiInstance = new KeyManagementApi(defaultClient);

    PersonalAccessTokenCreateRequest body =
        new PersonalAccessTokenCreateRequest()
            .data(
                new PersonalAccessTokenCreateData()
                    .type(PersonalAccessTokensType.PERSONAL_ACCESS_TOKENS)
                    .attributes(
                        new PersonalAccessTokenCreateAttributes()
                            .name("Example-Key-Management")
                            .scopes(Collections.singletonList("dashboards_read"))
                            .expiresAt(OffsetDateTime.now().plusDays(365))));

    try {
      PersonalAccessTokenCreateResponse result = apiInstance.createPersonalAccessToken(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyManagementApi#createPersonalAccessToken");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```python
"""
Create a personal access token returns "Created" response
"""

from datetime import datetime
from dateutil.relativedelta import relativedelta
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.key_management_api import KeyManagementApi
from datadog_api_client.v2.model.personal_access_token_create_attributes import PersonalAccessTokenCreateAttributes
from datadog_api_client.v2.model.personal_access_token_create_data import PersonalAccessTokenCreateData
from datadog_api_client.v2.model.personal_access_token_create_request import PersonalAccessTokenCreateRequest
from datadog_api_client.v2.model.personal_access_tokens_type import PersonalAccessTokensType

body = PersonalAccessTokenCreateRequest(
    data=PersonalAccessTokenCreateData(
        type=PersonalAccessTokensType.PERSONAL_ACCESS_TOKENS,
        attributes=PersonalAccessTokenCreateAttributes(
            name="Example-Key-Management",
            scopes=[
                "dashboards_read",
            ],
            expires_at=(datetime.now() + relativedelta(days=365)),
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = KeyManagementApi(api_client)
    response = api_instance.create_personal_access_token(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Create a personal access token returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::KeyManagementAPI.new

body = DatadogAPIClient::V2::PersonalAccessTokenCreateRequest.new({
  data: DatadogAPIClient::V2::PersonalAccessTokenCreateData.new({
    type: DatadogAPIClient::V2::PersonalAccessTokensType::PERSONAL_ACCESS_TOKENS,
    attributes: DatadogAPIClient::V2::PersonalAccessTokenCreateAttributes.new({
      name: "Example-Key-Management",
      scopes: [
        "dashboards_read",
      ],
      expires_at: (Time.now + 365 * 86400),
    }),
  }),
})
p api_instance.create_personal_access_token(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```rust
// Create a personal access token returns "Created" response
use chrono::{DateTime, Utc};
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_key_management::KeyManagementAPI;
use datadog_api_client::datadogV2::model::PersonalAccessTokenCreateAttributes;
use datadog_api_client::datadogV2::model::PersonalAccessTokenCreateData;
use datadog_api_client::datadogV2::model::PersonalAccessTokenCreateRequest;
use datadog_api_client::datadogV2::model::PersonalAccessTokensType;

#[tokio::main]
async fn main() {
    let body = PersonalAccessTokenCreateRequest::new(PersonalAccessTokenCreateData::new(
        PersonalAccessTokenCreateAttributes::new(
            DateTime::parse_from_rfc3339("2022-11-11T11:11:11+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
            "Example-Key-Management".to_string(),
            vec!["dashboards_read".to_string()],
        ),
        PersonalAccessTokensType::PERSONAL_ACCESS_TOKENS,
    ));
    let configuration = datadog::Configuration::new();
    let api = KeyManagementAPI::with_config(configuration);
    let resp = api.create_personal_access_token(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create a personal access token returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.KeyManagementApi(configuration);

const params: v2.KeyManagementApiCreatePersonalAccessTokenRequest = {
  body: {
    data: {
      type: "personal_access_tokens",
      attributes: {
        name: "Example-Key-Management",
        scopes: ["dashboards_read"],
        expiresAt: new Date(new Date().getTime() + 365 * 86400 * 1000),
      },
    },
  },
};

apiInstance
  .createPersonalAccessToken(params)
  .then((data: v2.PersonalAccessTokenCreateResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
